/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package masterrmiclient;

import clientCommunicator.rmi.RMIServicesInterface;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

/**
 *
 * @author Thomas Rudfoss
 */
public class Main {

    public static final String appName = "RMIClient";
    public static final String versionNr = "0.1a";
    public static final String author = "Thomas Haugland Rudfoss";

    public static final String RMIUrl = "rmi://127.0.0.1/MasterRMIInterface";

    public static MainWindow mw;
    public static AdminWindow aw;

    public static RMIServicesInterface server;
    public static boolean isConnected = false;

    public static void main(String[] args) {
        printAppInfo();
        showMainWindow();
    }

    public static void showMainWindow(){
        mw = new MainWindow();
        aw = new AdminWindow();
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                mw.setVisible(true);
                aw.setVisible(true);
            }
        });
    }

    public static void printAppInfo(){
        System.out.println(appName);
        System.out.println(versionNr);
        System.out.println(author);
        System.out.println("");
    }

    public static boolean connect(){
        try {
            server = (RMIServicesInterface) Naming.lookup(RMIUrl);
            isConnected = true;
            return true;
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        } catch (NotBoundException e) {
            e.printStackTrace();
        }
        isConnected = false;

        return false;
    }

    public static void test_PingRMI(){
        try {
            server.ping("message");
        } catch (RemoteException ex) {
            ex.printStackTrace();
        }
    }

}
