/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MainWindow.java
 *
 * Created on 21.apr.2010, 12:58:09
 */

package masterrmiclient;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.rmi.RemoteException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.XML;

/**
 *
 * @author Thomas Rudfoss
 */
public class MainWindow extends javax.swing.JFrame {

    /** Creates new form MainWindow */
    public MainWindow() {
        initComponents();
        tokenPanel.setVisible(false);
        this.setTitle("Data requests");
        statusLabel.setText("Connecting...");
        if ( Main.connect() ){
            statusLabel.setText("Connected!");
        } else {
            statusLabel.setText("Connection failed!");
        }

        repeatTimes.setValue(1);
        repeatTimes.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent ce) {
                repeatTimesChange();
            }
        });
        initDialogs();
    }

    public void setStatusText(String txt){
        this.statusLabel.setText(txt);
    }

    private void repeatTimesChange(){
        Integer val = (Integer) repeatTimes.getValue();
        if ( val < 1 ) repeatTimes.setValue(1);
    }

    private void initDialogs(){
        this.openDialog = new JFileChooser("C:\\");
        this.openDialog.setMultiSelectionEnabled(false);
        this.openDialog.setToolTipText("Select a file to open");
        this.openDialog.setDialogTitle("Choose a file");
        this.openDialog.setDialogType(JFileChooser.OPEN_DIALOG);


        this.saveDialog = new JFileChooser("C:\\");
        this.saveDialog.setMultiSelectionEnabled(false);
        this.saveDialog.setToolTipText("Save reponse");
        this.saveDialog.setDialogTitle("Save response");
        this.saveDialog.setDialogType(JFileChooser.SAVE_DIALOG);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        formatCombobox = new javax.swing.JComboBox();
        sendButton = new javax.swing.JButton();
        openFileButton = new javax.swing.JButton();
        repeatTimes = new javax.swing.JSpinner();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        requestTextarea = new javax.swing.JTextArea();
        toXML = new javax.swing.JButton();
        toJSON = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        responseTextarea = new javax.swing.JTextArea();
        saveResponseButton = new javax.swing.JButton();
        statusLabel = new javax.swing.JLabel();
        reconnect_button = new javax.swing.JButton();
        tokenPanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        tokenField = new javax.swing.JTextField();
        lockTokenButton = new javax.swing.JButton();
        tokenStatusLabel = new javax.swing.JLabel();

        jButton1.setText("jButton1");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setName("mainWindow"); // NOI18N

        formatCombobox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "XML (internal format)", "JSON" }));

        sendButton.setText("Send");
        sendButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sendButtonActionPerformed(evt);
            }
        });

        openFileButton.setText("Open file");
        openFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openFileButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(openFileButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(formatCombobox, 0, 215, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(repeatTimes, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(sendButton))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(openFileButton)
                    .addComponent(formatCombobox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(sendButton)
                    .addComponent(repeatTimes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jLabel1.setText("Request");

        requestTextarea.setColumns(20);
        requestTextarea.setFont(new java.awt.Font("Courier New", 0, 13)); // NOI18N
        requestTextarea.setRows(5);
        requestTextarea.setName("requestText"); // NOI18N
        jScrollPane1.setViewportView(requestTextarea);

        toXML.setText("to XML");
        toXML.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toXMLActionPerformed(evt);
            }
        });

        toJSON.setText("to JSON");
        toJSON.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toJSONActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addContainerGap(366, Short.MAX_VALUE))
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGap(264, 264, 264)
                .addComponent(toJSON)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(toXML))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(toXML)
                    .addComponent(toJSON)))
        );

        jLabel2.setText("Response");

        responseTextarea.setColumns(20);
        responseTextarea.setEditable(false);
        responseTextarea.setFont(new java.awt.Font("Courier New", 0, 13));
        responseTextarea.setRows(5);
        responseTextarea.setName("responseText"); // NOI18N
        jScrollPane2.setViewportView(responseTextarea);

        saveResponseButton.setText("Save response");
        saveResponseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveResponseButtonActionPerformed(evt);
            }
        });

        statusLabel.setText("Not connected!");

        reconnect_button.setText("Reconnect");
        reconnect_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reconnect_buttonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jLabel2)
                .addContainerGap(359, Short.MAX_VALUE))
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addComponent(statusLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 140, Short.MAX_VALUE)
                .addComponent(reconnect_button)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(saveResponseButton))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(saveResponseButton)
                    .addComponent(statusLabel)
                    .addComponent(reconnect_button)))
        );

        jLabel3.setText("Your token:");

        lockTokenButton.setText("Lock / unlock");
        lockTokenButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lockTokenButtonActionPerformed(evt);
            }
        });

        tokenStatusLabel.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        tokenStatusLabel.setText("Unverified");

        javax.swing.GroupLayout tokenPanelLayout = new javax.swing.GroupLayout(tokenPanel);
        tokenPanel.setLayout(tokenPanelLayout);
        tokenPanelLayout.setHorizontalGroup(
            tokenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(tokenPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(tokenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(tokenPanelLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 301, Short.MAX_VALUE)
                        .addComponent(tokenStatusLabel))
                    .addGroup(tokenPanelLayout.createSequentialGroup()
                        .addComponent(tokenField, javax.swing.GroupLayout.DEFAULT_SIZE, 307, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lockTokenButton)))
                .addContainerGap())
        );
        tokenPanelLayout.setVerticalGroup(
            tokenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(tokenPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(tokenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(tokenStatusLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(tokenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(tokenField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lockTokenButton))
                .addContainerGap(6, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(tokenPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(tokenPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(22, 22, 22))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void openFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openFileButtonActionPerformed
        String lineSep = System.getProperty("line.separator");
        if ( this.openDialog.showOpenDialog(this) != JFileChooser.APPROVE_OPTION ){
            return;
        }

        File f = this.openDialog.getSelectedFile();
        if ( f == null ){
            return;
        }
        
        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(f)));
            String line = new String();
            StringBuffer sb = new StringBuffer();
            while ( (line = reader.readLine()) != null ){
                sb.append(line);
                sb.append(lineSep);
            }

            this.requestTextarea.setText(sb.toString());
            reader.close();
        } catch (FileNotFoundException ex) {
            JOptionPane.showMessageDialog(this, "File not found!", "Error", JOptionPane.ERROR_MESSAGE);
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this, "Unknown IOException occured!", "Error", JOptionPane.ERROR_MESSAGE);
            ex.printStackTrace();
        }

    }//GEN-LAST:event_openFileButtonActionPerformed

    private void lockTokenButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lockTokenButtonActionPerformed
        if ( this.tokenField.isEditable() ){
            this.tokenStatusLabel.setText("Verifying token...");

            //Verify token
            if ( Main.isConnected ){
                try {
                    if (Main.server.verifyToken(tokenField.getText())) {
                        this.tokenStatusLabel.setText("Verified");
                    } else {
                        this.tokenStatusLabel.setText("Unknown/Invalid");
                        return;
                    }
                } catch (RemoteException ex) {
                    this.tokenStatusLabel.setText("Could not verify!");
                    return;
                }
            } else {
                this.tokenStatusLabel.setText("Could not verify! (not connected)");
                return;
            }
        }
        
        tokenField.setEditable(!tokenField.isEditable());
}//GEN-LAST:event_lockTokenButtonActionPerformed

    private void saveResponseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveResponseButtonActionPerformed
        if ( this.saveDialog.showSaveDialog(this) != JFileChooser.APPROVE_OPTION ){
            return;
        }

        File f = this.saveDialog.getSelectedFile();
        if ( f == null ){
            return;
        }
        try {
            if ( f.exists() ){
                if ( JOptionPane.showConfirmDialog(this, "Overwrite?", "Overwrite file", JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION ) return;
                f.delete();
            }
            
            f.createNewFile();
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this, "Could not create file. Access denied maybe?", "Error", JOptionPane.ERROR_MESSAGE);
            ex.printStackTrace();
        }
        try {
            OutputStreamWriter writer = new OutputStreamWriter(new FileOutputStream(f));
            writer.write(this.responseTextarea.getText());
            writer.close();
        } catch (FileNotFoundException ex) {
            JOptionPane.showMessageDialog(this, "Could not write to file. File does not exist", "Error", JOptionPane.ERROR_MESSAGE);
        } catch (IOException ex){
            JOptionPane.showMessageDialog(this, "Could not write to file. IOException occured", "Error", JOptionPane.ERROR_MESSAGE);
            ex.printStackTrace();
        }

    }//GEN-LAST:event_saveResponseButtonActionPerformed

    private void sendButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendButtonActionPerformed
        if ( Main.isConnected ){
            StringBuilder res = new StringBuilder();

            int count = ((Integer) repeatTimes.getValue());
            while ( count > 0 ){
                count--;
                switch ( this.formatCombobox.getSelectedIndex() ){
                    case 0:
                        //XML
                        try {
                            String intRes = new String();
                            intRes = Main.server.xmlRequest(this.requestTextarea.getText(), this.tokenField.getText());
                            if ( intRes.length() > 0 ) res.append(intRes).append(System.getProperty("line.separator"));
                            else res.append("NULL result").append(System.getProperty("line.separator"));
                        } catch (RemoteException ex) {
                            res.append("Remote exception occured!").append(System.getProperty("line.separator"));
                            ex.printStackTrace();
                        }
                        break;
                    case 1:
                        //JSON
                        try {
                            String intRes = new String();
                            intRes = Main.server.jsonRequest(this.requestTextarea.getText(), this.tokenField.getText());
                            if ( intRes.length() > 0 ) res.append(intRes).append(System.getProperty("line.separator"));
                            else res.append("NULL result").append(System.getProperty("line.separator"));
                        } catch (RemoteException ex) {
                            res.append("Remote exception occured!").append(System.getProperty("line.separator"));
                            ex.printStackTrace();
                        }
                        break;
                    default:
                        res.append(System.getProperty("line.separator")).append("Format invalid!");
                        count = -1;
                        break;
                }
            }

            responseTextarea.setText(res.toString());
        }
    }//GEN-LAST:event_sendButtonActionPerformed

    private void reconnect_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reconnect_buttonActionPerformed
        this.statusLabel.setText("Attempting to reconnect...");
        if ( Main.connect() ) this.statusLabel.setText("Connected!");
        else this.statusLabel.setText("Falied to reconnect!");
    }//GEN-LAST:event_reconnect_buttonActionPerformed

    private void toJSONActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toJSONActionPerformed
        try {
            requestTextarea.setText(XML.toJSONObject(requestTextarea.getText()).toString());
        } catch (JSONException ex) {
            JOptionPane.showMessageDialog(this, "Could not convert input to JSON. Make sure the XML is valid.");
        }
    }//GEN-LAST:event_toJSONActionPerformed

    private void toXMLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toXMLActionPerformed
        try {
            JSONObject jso = new JSONObject(requestTextarea.getText());
            requestTextarea.setText(XML.toString(jso));
        } catch (JSONException ex) {
            JOptionPane.showMessageDialog(this, "Could not convert input to JSON. Make sure the XML is valid.");
        }
    }//GEN-LAST:event_toXMLActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox formatCombobox;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton lockTokenButton;
    private javax.swing.JButton openFileButton;
    private javax.swing.JButton reconnect_button;
    private javax.swing.JSpinner repeatTimes;
    private javax.swing.JTextArea requestTextarea;
    private javax.swing.JTextArea responseTextarea;
    private javax.swing.JButton saveResponseButton;
    private javax.swing.JButton sendButton;
    private javax.swing.JLabel statusLabel;
    private javax.swing.JButton toJSON;
    private javax.swing.JButton toXML;
    private javax.swing.JTextField tokenField;
    private javax.swing.JPanel tokenPanel;
    private javax.swing.JLabel tokenStatusLabel;
    // End of variables declaration//GEN-END:variables

    private javax.swing.JFileChooser openDialog;
    private javax.swing.JFileChooser saveDialog;
}
