package clientCommunicator;

/**
 * Should be extended by a communicator manager. This allows the core to close all open communications properly.
 * 
 * @author Thomas Rudfoss
 *
 */
public interface ClientCommunicatorManager {
	
	/**
	 * Signal the ClientCommunicatorManager to begin operations.
	 */
	public void start();
	
	/**
	 * Signals the ClientCommunicatorManager to stop all ongoing operations and notify any
	 * active clients that their jobs have stopped prematurely.
	 */
	public void stop();
	
}
