package core;

public enum ResponseTemplateTypes {
	
	BASIC("{\"response\":{\"responsespec\":{\"status\":0,\"statusmessage\":\"\"},\"data\":{}}}"),
	
	ACCESS_DENIED("{\"response\":{\"responsespec\":{\"status\":10,\"statusmessage\":\"Not enough priveliges.\"}}}"),
	UKNOWN_USER("{\"response\":{\"responsespec\":{\"status\":20,\"statusmessage\":\"User not found.\"}}}"),
	
	INVALID_REQUEST("{\"response\":{\"responsespec\":{\"status\":30,\"statusmessage\":\"The request is not properly formatted.\"}}}"),
	
	SERVER_BUSY("{\"response\":{\"responsespec\":{\"status\":40,\"statusmessage\":\"Server busy. No more available job slots.\"}}}"),
	NO_JOBEXECUTOR("{\"response\":{\"responsespec\":{\"status\":42,\"statusmessage\":\"The system cannot perform the requested job.\"}}}"),
	NO_JOBTRANSLATOR("{\"response\":{\"responsespec\":{\"status\":44,\"statusmessage\":\"The system cannot translte to the requested result format.\"}}}"),
	
	JOB_TIMEOUT("{\"response\":{\"responsespec\":{\"status\":50,\"statusmessage\":\"The job timed out.\"}}}"),
	JOB_CANCELED("{\"response\":{\"responsespec\":{\"status\":60,\"statusmessage\":\"The job was canceled.\"}}}"),
	
	SERVER_ERROR("{\"response\":{\"responsespec\":{\"status\":100,\"statusmessage\":\"Internal error on server. Job could not be completed.\"}}}");
	
	public final String json;
	
	ResponseTemplateTypes(String jsonText){
		this.json = jsonText;
	}

}
