package resultTranslators;

import org.json.JSONException;
import org.json.XML;

import core.Core;
import core.Job;

/**
 * Translates the result into an xml document
 * 
 * @author Thomas Rudfoss
 *
 */
public class XMLTranslator implements ResultTranslatorInterface{
	
	public static String[] iCanTranslateTo(){
		return new String[]{"xml"};
	}

	@Override
	public void translateJob(Job job, String toFormat) {
		Core.getCore().getPluginLogger().finer("XMLTranslator: Translating job...");
		try {
			Core.getCore().getPluginLogger().finest("XMLTranslator: Internal result: "+job.internalResult);
			job.result = XML.toString(job.internalResult);
			job.time_translated = System.currentTimeMillis();
			job.state = Job.STATE_RESULT_TRANSLATED;
			Core.getCore().getPluginLogger().finest("XMLTranslator: Final result: "+job.result);
			Core.getCore().getPluginLogger().finer("XMLTranslator: Job successfully translated");
		} catch (JSONException e) {
			Core.getCore().getPluginLogger().warning("XMLTranslator: Translation failed for: "+job.internalResult.toString());
			Core.getCore().getPluginLogger().warning(Core.stackTraceToString(e));
			job.state = Job.STATE_FAILED;
			job.result = "";
		}
	}

}
